package com.ekingwin.bas.cloud.dataDictionary.dao;

import java.util.List;

import com.ekingwin.bas.cloud.dataDictionary.dto.DataDictionaryDto;
import com.ekingwin.bas.cloud.dataDictionary.dto.DataDictionaryVo;
import org.apache.ibatis.annotations.Param;

import com.ekingwin.bas.cloud.dataDictionary.dao.entity.DataDictionary;
import com.ekingwin.bas.cloud.dataDictionary.dao.entity.DataDictionaryOption;
import com.ekingwin.bas.cloud.dataDictionary.dto.DataDictionaryOptionDto;
import com.ekingwin.bas.cloud.infra.exception.BasException;
import com.ekingwin.bas.mapper.BasMapper;

public interface DataDictionaryDao extends BasMapper<DataDictionary>{
	public List<DataDictionaryOption> getByDictionaryen(@Param("dictionaryen")String dictionaryen) throws BasException;
	public List<DataDictionaryOption> getByDictionaryenAndOptionValue(@Param("dictionaryen")String dictionaryen,@Param("value")String value) throws BasException;
	public void deleteOptionsByPid(@Param("pid")String pid) throws BasException;
	public List<DataDictionaryOption> queryOptionByDicId(@Param("dictionaryId")String dictionaryId) ;
	/**
	 * 根据模块和数据字典标识获取下拉框
	 * @param dataDictionaryDto
	 * @return
	 */
	List<DataDictionaryVo> getByDictionaryenAndModel(DataDictionaryDto dataDictionaryDto);

	/**
	 * 修改字典主表内容
	 */
	int updateDic(DataDictionaryDto dataDictionaryDto);

	/**
	 * 新增字典主表内容
	 */
	int insertDic(DataDictionaryDto dataDictionaryDto);

	/**
	 * 删除字典选项内容
	 */
	int deleteDicOption(@Param(value="pId") String pId);

	/**
	 * 新增字典选项内容
	 */
	int insertDicOption(DataDictionaryOptionDto dataDictionaryOptionDto);















}
