package com.ekingwin.bas.cloud.document.service;

import org.springframework.http.ResponseEntity;

import com.ekingwin.bas.cloud.document.UAttachementException;
import com.ekingwin.bas.cloud.document.dto.UploadFileObject;

/**
 * 文件下载接口，该接口定义了文件下载功能；该接口为附件管理组件内部使用，不应该暴露给其他使用者
 * @author chenjb
 *
 */
public interface IIDownloadService {

	/**
	 * 下载文件
	 * @param id	文件ID
	 * @return FileObject	下载的文件对象
	 * @throws UAttachementException
	 */
	public UploadFileObject downloadFile(String id) throws UAttachementException;
	
	public ResponseEntity<byte[]> downloadFileByte(String id) throws UAttachementException;

	public ResponseEntity<byte[]> downloadFileByte(String id, boolean b) throws UAttachementException;


}
