package com.ekingwin.bas.cloud.org.dao;

import com.ekingwin.bas.cloud.org.OrganizationException;
import com.ekingwin.bas.cloud.org.dao.entity.OrganizationTree;
import com.ekingwin.bas.cloud.org.dto.OrganizationTreeDto;
import com.ekingwin.bas.mapper.BasMapper;
import org.apache.ibatis.annotations.Param;
import tk.mybatis.mapper.entity.Example;

import java.util.List;

public interface IOrganizationTreeDao extends BasMapper<OrganizationTree> {

	public void batchDeleteById(String id);
	public List<OrganizationTree> getChildTreeById(String id);
	public List<OrganizationTree> getDirectChildTreeById(@Param(value = "id") String id,
														 @Param(value = "isPost") String isPost);
	public List<OrganizationTree> getDirectChildTreeByIds(String id);
	public OrganizationTree hasChildTreeById(String id);
	
	public List<OrganizationTree> getOrgByUser(@Param("example")Example example,@Param("userid")String userid);
	
	public List<OrganizationTree> getChildCompanyById(String id);
	
	public List<OrganizationTree> findFirstTree(String id);
	public List<OrganizationTree> getFirstTree(String id);
	
	public OrganizationTreeDto getOrgTreeByid(@Param("id")String id,@Param("logid")String logid);
	public List<OrganizationTree> getOrganizationTreeByUserId(@Param("example")Example example,@Param("userid")String userid);
	public List<OrganizationTree> queryOrgTree() throws Exception;
	public void genTreecode() throws OrganizationException;
	public void insertTreeByOrg() throws OrganizationException;
	/**
	 * 获取当前用户的租户一级组织
	 * @param id
	 * @return
	 */
	public List<OrganizationTree> getTenantOrganizationByUserId(@Param("currentuserid")String currentuserid);
	
}
