package com.ekingwin.bas.cloud.org.dto;

import com.ekingwin.bas.cloud.infra.dto.BaseDTO;
import com.fasterxml.jackson.annotation.JsonFormat;
import io.swagger.annotations.ApiModelProperty;

import java.util.Date;
import java.util.List;

public class OrganizationDto extends BaseDTO {
	
	public static final String TYPE_COMPANY = "1";
	public static final String TYPE_DEPT = "2";
	public static final String TYPE_POST = "3";
	public static final String TYPE_BIZ = "4";
	public static final String TYPE_BIZ_ENTITY = "5";

	/**
	 * 
	 */
	private static final long serialVersionUID = 8540924683985529428L;
	private		String			id;							//主键
	private		String			name;						//名称
	private		String			enname;						//英文名称
	private		String			code;						//编号
	private		String			fullname;					//全名
	private		String			type;						//类型 1:公司,2:部门,3:岗位,4:事业部,5:业务实体
	private		String 			othersystemid;				//其他系统ID
	private		String			isdelete;					//是否删除
	private		String			attribute1;					//备用字段
	private		String			attribute2;
	private		String			attribute3;
	private		String			pcode;                      //上级组织机构代码
	private		String			currency;                   //货币
	private		String			language;                   //语言
	private		String			vatnumber;                  //增值税登记号
	private		String			address;                    //地址
	private		String			postno;                     //邮政编码
	private		String			post_box;                   //邮政信箱
	private		String			legalrepresentative;        //法人代表
	private		String			contact;                    //联系人
	private		String			phone;                      //电话
	private		String			mobilephone;                //移动电话
	private		String			fax;                        //传真
	private		String			subtype;                    //子类型
	private		String			comtype;                    //公司所属类型
	private		String			acctarea;                   //核算区域
	private		String			werks;                      //人事范围
	private		String			subranges;                  //人事子范围
	private		String			costcenter;                 //成本中心
	private		String			bussscope;                  //业务范围
	private		String			shortname;                  //组织单位简称
	private		Date			updatetime = new Date();    //更新时间
	private		String			area;                       //城市
	private		String			mail;                       //邮箱
	private		String			companycode;                //成本中心对应公司编码、
	private 	String 			rank        ;//排序			
	private		String			topdept;
	private     String          hrtype;              	  	//组织类型HR
	private     String          approvalorgdesc ;       	//审批组织分类描述
	private     String          postid ;       				//职务编码
	private     String          postname ;       				//职务名称
	private     String          ppostcode ;       				//职务编码
	private     String          workmark ;       				//主持工作
	private     String          linecode ;       				//条线
	private     String          plate ;       				//板块
	private     String          business ;       				//主营业务
	private     String          sharetype ;       				//控股类型
	@JsonFormat( pattern="yyyy-MM-dd HH:mm:ss")  
	private Date effectivedate;								//生效日期
	@JsonFormat( pattern="yyyy-MM-dd HH:mm:ss")  
	private Date expiredate;								//失效日期
	private String factory;                                 //工厂(业务属性)
	private String suoshutype;                              //所属类型
//	private String brand;                                   //品牌(业务属性)
//	private String paymentway;			                    //付款方式(业务属性)
	private String pid;                                     //上级组织id
//	private String spostid;                                 //上级岗位id 岗位专用   
//	private String fullroute;								//全路径

	@ApiModelProperty(value = "是否显示岗位")
	private String isPost;

	public String getIsPost() {
		return isPost;
	}

	public void setIsPost(String isPost) {
		this.isPost = isPost;
	}

	private     List<OrganizationDto>          childs ;       				//
	
	
	public String getPid() {
		return pid;
	}

	public void setPid(String pid) {
		this.pid = pid;
	}

	public String getId() {
		return id;
	}

	public void setId(String id) {
		this.id = id;
	}

	public String getName() {
		return name;
	}

	public void setName(String name) {
		this.name = name;
	}

	public String getEnname() {
		return enname;
	}

	public void setEnname(String enname) {
		this.enname = enname;
	}

	public String getCode() {
		return code;
	}

	public void setCode(String code) {
		this.code = code;
	}

	public String getFullname() {
		return fullname;
	}

	public void setFullname(String fullname) {
		this.fullname = fullname;
	}

	public String getType() {
		return type;
	}

	public void setType(String type) {
		this.type = type;
	}

	public String getOthersystemid() {
		return othersystemid;
	}

	public void setOthersystemid(String othersystemid) {
		this.othersystemid = othersystemid;
	}

	public String getAttribute1() {
		return attribute1;
	}

	public void setAttribute1(String attribute1) {
		this.attribute1 = attribute1;
	}

	public String getAttribute2() {
		return attribute2;
	}

	public void setAttribute2(String attribute2) {
		this.attribute2 = attribute2;
	}

	public String getIsdelete() {
		return isdelete;
	}

	public void setIsdelete(String isdelete) {
		this.isdelete = isdelete;
	}

	public String getPcode() {
		return pcode;
	}

	public void setPcode(String pcode) {
		this.pcode = pcode;
	}

	public String getCurrency() {
		return currency;
	}

	public void setCurrency(String currency) {
		this.currency = currency;
	}

	public String getLanguage() {
		return language;
	}

	public void setLanguage(String language) {
		this.language = language;
	}

	public String getVatnumber() {
		return vatnumber;
	}

	public void setVatnumber(String vatnumber) {
		this.vatnumber = vatnumber;
	}

	public String getAddress() {
		return address;
	}

	public void setAddress(String address) {
		this.address = address;
	}

	public String getPostno() {
		return postno;
	}

	public void setPostno(String postno) {
		this.postno = postno;
	}

	public String getPost_box() {
		return post_box;
	}

	public void setPost_box(String post_box) {
		this.post_box = post_box;
	}

	public String getLegalrepresentative() {
		return legalrepresentative;
	}

	public void setLegalrepresentative(String legalrepresentative) {
		this.legalrepresentative = legalrepresentative;
	}

	public String getContact() {
		return contact;
	}

	public void setContact(String contact) {
		this.contact = contact;
	}

	public String getPhone() {
		return phone;
	}

	public void setPhone(String phone) {
		this.phone = phone;
	}

	public String getMobilephone() {
		return mobilephone;
	}

	public void setMobilephone(String mobilephone) {
		this.mobilephone = mobilephone;
	}

	public String getFax() {
		return fax;
	}

	public void setFax(String fax) {
		this.fax = fax;
	}

	public String getSubtype() {
		return subtype;
	}

	public void setSubtype(String subtype) {
		this.subtype = subtype;
	}

	public String getComtype() {
		return comtype;
	}

	public void setComtype(String comtype) {
		this.comtype = comtype;
	}

	public String getAcctarea() {
		return acctarea;
	}

	public void setAcctarea(String acctarea) {
		this.acctarea = acctarea;
	}

	public String getSubranges() {
		return subranges;
	}

	public void setSubranges(String subranges) {
		this.subranges = subranges;
	}

	public String getCostcenter() {
		return costcenter;
	}

	public void setCostcenter(String costcenter) {
		this.costcenter = costcenter;
	}

	public String getBussscope() {
		return bussscope;
	}

	public void setBussscope(String bussscope) {
		this.bussscope = bussscope;
	}

	public String getShortname() {
		return shortname;
	}

	public void setShortname(String shortname) {
		this.shortname = shortname;
	}

	

	public Date getUpdatetime() {
		return updatetime;
	}

	public void setUpdatetime(Date updatetime) {
		this.updatetime = updatetime;
	}

	public String getArea() {
		return area;
	}

	public void setArea(String area) {
		this.area = area;
	}

	public String getMail() {
		return mail;
	}

	public void setMail(String mail) {
		this.mail = mail;
	}
	
	public String getWerks() {
		return werks;
	}

	public void setWerks(String werks) {
		this.werks = werks;
	}

	public String getAttribute3() {
		return attribute3;
	}

	public void setAttribute3(String attribute3) {
		this.attribute3 = attribute3;
	}

	public String getCompanycode() {
		return companycode;
	}

	public void setCompanycode(String companycode) {
		this.companycode = companycode;
	}

	public String getTopdept() {
		return topdept;
	}

	public void setTopdept(String topdept) {
		this.topdept = topdept;
	}
	
	
	public String getRank() {
		return rank;
	}

	public void setRank(String rank) {
		this.rank = rank;
	}
	
	public String getHrtype() {
		return hrtype;
	}

	public void setHrtype(String hrtype) {
		this.hrtype = hrtype;
	}

	public String getApprovalorgdesc() {
		return approvalorgdesc;
	}

	public void setApprovalorgdesc(String approvalorgdesc) {
		this.approvalorgdesc = approvalorgdesc;
	}

	public String getPostid() {
		return postid;
	}

	public void setPostid(String postid) {
		this.postid = postid;
	}

	public String getPpostcode() {
		return ppostcode;
	}

	public void setPpostcode(String ppostcode) {
		this.ppostcode = ppostcode;
	}

	public String getWorkmark() {
		return workmark;
	}

	public void setWorkmark(String workmark) {
		this.workmark = workmark;
	}

	public String getLinecode() {
		return linecode;
	}

	public void setLinecode(String linecode) {
		this.linecode = linecode;
	}

	public Date getEffectivedate() {
		return effectivedate;
	}

	public void setEffectivedate(Date effectivedate) {
		this.effectivedate = effectivedate;
	}

	public Date getExpiredate() {
		return expiredate;
	}

	public void setExpiredate(Date expiredate) {
		this.expiredate = expiredate;
	}

	public String getPlate() {
		return plate;
	}

	public void setPlate(String plate) {
		this.plate = plate;
	}

	public String getBusiness() {
		return business;
	}

	public void setBusiness(String business) {
		this.business = business;
	}

	public String getSharetype() {
		return sharetype;
	}

	public void setSharetype(String sharetype) {
		this.sharetype = sharetype;
	}

	public String getPostname() {
		return postname;
	}

	public void setPostname(String postname) {
		this.postname = postname;
	}

	public String getFactory() {
		return factory;
	}

	public void setFactory(String factory) {
		this.factory = factory;
	}

	public String getSuoshutype() {
		return suoshutype;
	}

	public void setSuoshutype(String suoshutype) {
		this.suoshutype = suoshutype;
	}

	public List<OrganizationDto> getChilds() {
		return childs;
	}

	public void setChilds(List<OrganizationDto> childs) {
		this.childs = childs;
	}
	
}
