package com.ekingwin.bas.cloud.tenant.service.impl;

import java.util.ArrayList;
import java.util.List;

import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.context.annotation.Primary;
import org.springframework.stereotype.Service;

import com.ekingwin.bas.cloud.infra.dto.BaseResult;
import com.ekingwin.bas.cloud.infra.dto.QueryDTO;
import com.ekingwin.bas.cloud.infra.exception.BasException;
import com.ekingwin.bas.cloud.infra.service.BaseService;
import com.ekingwin.bas.cloud.infra.utils.common.ResultUtils;
import com.ekingwin.bas.cloud.infra.utils.db.PageCriteria;
import com.ekingwin.bas.cloud.tenant.dao.TenantDao;
import com.ekingwin.bas.cloud.tenant.dao.entity.Tenant;
import com.ekingwin.bas.cloud.tenant.dao.entity.TenantOrganization;
import com.ekingwin.bas.cloud.tenant.dto.TenantDto;
import com.ekingwin.bas.cloud.tenant.dto.TenantOrganizationDto;
import com.ekingwin.bas.cloud.tenant.service.ITenantService;
import com.ekingwin.bas.cloud.user.dto.UserDto;

@Primary
@Service
public class TenantServiceImpl extends BaseService implements ITenantService {
	@Autowired
	private TenantDao dao;

	@Override
	public BaseResult<TenantDto> save(TenantDto object) throws BasException {
		save(object, Tenant.class, dao);
		return null;
	}

	@Override
	public BaseResult<TenantDto> delete(String id) throws BasException {
		// TODO Auto-generated method stub
		return null;
	}

	@Override
	public BaseResult<PageCriteria<TenantDto>> query(QueryDTO query) throws BasException {
		// TODO Auto-generated method stub
		return null;
	}

	@Override
	public BaseResult<TenantDto> get(String id) throws BasException {
		TenantDto result = get(TenantDto.class, id, dao);
		return ResultUtils.build(result);
	}

	@Override
	public TenantDto getByCreditcode(String creditcode) throws BasException {
		TenantDto tenantDto = null;
		List<Tenant> tenantList = dao.getTenantByCreditcode(creditcode);
		if(tenantList.size()>0){
			tenantDto = new TenantDto();
			try {
				super.commonBuild(tenantDto, tenantList.get(0));
			} catch (Exception e) {
				log.info(e.getMessage());
			}
		}
		return tenantDto;
	}

	@Override
	public List<TenantOrganizationDto> getTenantOrganizationByTenantid(String tenantid) throws BasException {
		List<TenantOrganizationDto> result = new ArrayList<TenantOrganizationDto>();
		List<TenantOrganization> tenantOrganizationList =  dao.getTenantOrganizationByTenantid(tenantid);
		for(int i = 0 ; i < tenantOrganizationList.size() ; i++ ){
			TenantOrganizationDto tenantOrganizationDto = new TenantOrganizationDto();
			try {
				super.commonBuild(tenantOrganizationDto, tenantOrganizationList.get(i));
				result.add(tenantOrganizationDto);
			} catch (Exception e) {
				// TODO Auto-generated catch block
				e.printStackTrace();
			}
		}
		return result;
	}
}
