package com.ekingwin.bas.cloud.user.dao;


import java.util.List;

import org.apache.ibatis.annotations.Param;

import tk.mybatis.mapper.entity.Example;

import com.ekingwin.bas.cloud.user.dao.entity.SystemUserEsb;
import com.ekingwin.bas.cloud.user.dto.SystemUserEsbDto;
import com.ekingwin.bas.mapper.BasMapper;

public interface ISystemUserEsbDao extends BasMapper<SystemUserEsb> {

	/**
	 * 查询用户条数
	 * @param code
	 * @param empid
	 * @param status
	 * @return
	 */
	public int getNumBySysCodes(@Param("syscode")String syscode, @Param("empid")String empid, @Param("status")String status);

	/**
	 * 获取10条推送数据
	 * @param example
	 * @return
	 */
	public List<SystemUserEsb> getSystemUserPush(@Param("example")Example example);

	/**
	 * 根据id删除推送数据
	 * @param id
	 */
	public void deleteSystemUserById(@Param("id")String id);

	/**
	 * 根据id修改推送数据状态
	 * @param id
	 */
	public void modifyStatus(@Param("id")String id);

	public SystemUserEsbDto getSystemUserById(@Param("id")String id);

	/**
	 * 根据系统编码和员工id查询是否有这条数据
	 * @param syscode
	 * @param empuid
	 * @return
	 */
	public int getUserNumBySyscodeAndUserid(@Param("syscode")String syscode, @Param("empuid")String empuid);

}

